import * as tailwind_factory_dist from 'tailwind-factory/dist';
import * as react from 'react';
import { ComponentProps } from 'react';
import { PrismTheme } from 'prism-react-renderer';

declare const HighlightContainer: ((props: react.ClassAttributes<HTMLDivElement> & react.HTMLAttributes<HTMLDivElement> & Partial<tailwind_factory_dist.FactoryExtractKeys<{
    full: {
        true: string;
        false: string;
    };
}>> & Required<Omit<tailwind_factory_dist.FactoryExtractKeys<{
    full: {
        true: string;
        false: string;
    };
}>, "full">>) => JSX.Element) & {
    __extends: <NewType extends tailwind_factory_dist.FactoryElement | null, NewStyleVariants, NewDefaultStyleVariants, NewDefaultStyleVariantsScheme extends tailwind_factory_dist.FactoryExtractKeys<tailwind_factory_dist.FactoryExtractRequiredKeysAndValues<{
        full: {
            true: string;
            false: string;
        };
    }> & NewStyleVariants>>(newElement?: NewType | undefined, newStyles?: string | undefined, newConfig?: tailwind_factory_dist.StyledElementOptions<NewStyleVariants & tailwind_factory_dist.FactoryExtractKeysAndValues<{
        full: {
            true: string;
            false: string;
        };
    }>, NewDefaultStyleVariants, NewDefaultStyleVariantsScheme> | undefined) => ((props: (NewType extends tailwind_factory_dist.FactoryElement ? react.ComponentProps<NewType> : react.DetailedHTMLProps<react.HTMLAttributes<HTMLDivElement>, HTMLDivElement>) & (NewDefaultStyleVariants extends infer C_1 ? Partial<{
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1 ? tailwind_factory_dist.FactoryExtractKeys<U_1> : any> & Required<Omit<{
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1_1 ? tailwind_factory_dist.FactoryExtractKeys<U_1_1> : any, "full" | keyof C_1>> : {
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1_2 ? tailwind_factory_dist.FactoryExtractKeys<U_1_2> : any)) => JSX.Element) & {
        __extends: any;
    };
};

declare const tokens: readonly ["char", "cdata", "doctype", "entity", "class-name", "boolean", "property", "function", "mayble-class-name", "method", "function-variable", "variable", "attr-name", "punctuation", "operator", "markup", "tag", "atrule", "deleted", "selector", "url", "string", "attr-value", "template-punctuation", "constant", "number", "builtin", "changed", "keyword", "interpolation-punctuation", "comment", "inserted", "important", "content", "null", "prolog", "blockquote", "hr", "code-snippet", "italic", "bold", "strike", "list", "title", "property-line", "property-declaration", "hexcode", "unit", "macro", "directive-hash", String];

declare const languages: readonly ["markup", "html", "bash", "clike", "c", "cpp", "css", "css-extras", "javascript", "jsx", "js-extras", "js-templates", "coffeescript", "diff", "git", "go", "graphql", "markup-templating", "handlebars", "json", "less", "makefile", "markdown", "objectivec", "ocaml", "python", "reason", "sass", "scss", "sql", "stylus", "tsx", "typescript", "wasm", "yaml", String];
type HighlightSupportedLanguages = (typeof languages)[number];

type HighlightThemePlain = PrismTheme["plain"] & {
    numbersColor?: string;
    numbersBackgroundColor?: string;
    numbersBorderColor?: string;
    srollbarThumbColor?: string;
    scrollbarTrackColor?: string;
};
type HighlightThemeStyle = {
    types: (typeof tokens)[number][];
    style: PrismTheme["styles"][number]["style"];
    languages?: HighlightSupportedLanguages[];
};
interface HighlightTheme extends Omit<PrismTheme, "styles"> {
    plain: HighlightThemePlain;
    styles: HighlightThemeStyle[];
}
declare class HighlightCustomTheme implements HighlightTheme {
    plain: HighlightThemePlain;
    styles: HighlightThemeStyle[];
    constructor(plain: HighlightThemePlain, styles?: HighlightThemeStyle[]);
    static extends(theme: HighlightTheme, plain: HighlightThemePlain, styles?: HighlightThemeStyle[]): HighlightCustomTheme;
}

declare const themes: {
    oneDark: HighlightCustomTheme;
    dracula: HighlightTheme;
    duotoneDark: HighlightTheme;
    duotoneLight: HighlightTheme;
    github: HighlightTheme;
    nightOwl: HighlightTheme;
    nightOwlLight: HighlightTheme;
    oceanicNext: HighlightTheme;
    palenight: HighlightTheme;
    okaidia: HighlightTheme;
    shadesOfPurple: HighlightTheme;
    synthwave84: HighlightTheme;
    ultramin: HighlightTheme;
    vsDark: HighlightTheme;
    vsLight: HighlightTheme;
};

type HighligthPluginDetails = {
    author: string;
    repository?: string;
    description?: string;
    version?: string;
};
type HighligthPluginKitData = {
    type: "kit";
    details: HighligthPluginDetails;
    language: HighlightSupportedLanguages;
    theme: HighlightTheme;
};
type HighligthPluginThemeData = {
    type: "theme";
    details: HighligthPluginDetails;
    theme: HighlightTheme;
};
type HighligthPluginLanguageData = {
    type: "language";
    details: HighligthPluginDetails;
    language: HighlightSupportedLanguages;
};
type HighligthPluginData = HighligthPluginKitData | HighligthPluginThemeData | HighligthPluginLanguageData;
declare class HighligthPlugin {
    plugin: HighligthPluginData;
    constructor(plugin: HighligthPluginData);
}

type HighlightDefaultTheme = keyof typeof themes;

interface HighlightProps extends ComponentProps<typeof HighlightContainer> {
    children: string;
    theme?: HighlightDefaultTheme | HighlightTheme;
    language?: HighlightSupportedLanguages;
    showNumbers?: boolean;
    showNumbersBorder?: boolean;
    numbersContainerClassName?: string;
    numbersClassName?: string;
    plugins?: HighligthPlugin[];
}

declare function Highlight({ children, theme, language, showNumbers, showNumbersBorder, numbersContainerClassName, numbersClassName, plugins, ...rest }: HighlightProps): JSX.Element;

export { HighlightCustomTheme, HighlightDefaultTheme, HighlightProps, HighlightTheme, HighlightThemePlain, HighlightThemeStyle, HighligthPluginDetails, HighligthPluginKitData, HighligthPluginLanguageData, HighligthPluginThemeData, Highlight as default, themes };
